<?php
namespace net\xmp\phpbook;
require './HTMLPage.php';
require './LDAPConnection.php';
$html = new HTMLPage('LDAP User Search');

// Connect
$ad = new LDAPConnection();
$ad->connect('doco-exch.xmp.site', 'arno@xmp.site', 'confidential');
// Query Users
$baseDN = "CN=users,DC=xmp,DC=site";
// Filter looks for user objects with the userPrincipalName attribute
$filter = "(&(objectcategory=Person)(userPrincipalName=*))";
// Definition of the attributes to retrieve
$attributes = array('name', 'userPrincipalName', 'sAMAccountName');
// Start search
$qresult = ldap_search($ad->handle, $baseDN, $filter, $attributes);
if (!$qresult) {
    $ad->exitWithError('LDAP search failed.');
}
// Retrieve entries ...
$entries = ldap_get_entries($ad->handle, $qresult);
if (!$entries) {
    $ad->exitWithError('Reading of LDAP failed.');
}
// ... and write in table
$table = array(array('Name', 'Principal', 'DN', 'Account Name'));
for ($i = 0; $i < $entries['count']; $i++) {
    $table[] = array($entries[$i]['name'][0], $entries[$i]['userprincipalname'][0],
                     $entries[$i]['dn'], $entries[$i]['samaccountname'][0]);
}
$html->addTable($table);

// Share result, close connection
ldap_free_result($qresult);
$ad->close();
$html->printPage();
?>
