/**
 * Converts the binary SID to a string
 * @param string $sid binary SID
 */
function sid2str($sid) {
    $v = unpack('Crev/Ccnt/Sx/Nauth/V*sub', $sid);
    $str = "S-$v[rev]-$v[auth]";
    for ($i = 1; $i <= $v['cnt']; $i++) {
        $str .= '-' . $v["sub$i"];
    }
    return $str;
}

/**
 * Converts the string to a binary SID
 * @param string $sidstr SID as string
 */
function str2sid($sidstr) {
    $v = explode('-', $sidstr);
    $cnt = count($v) - 3;
    $sid = pack('CCSN', $v[1], $cnt, 0, $v[2]);
    for ($i = 0; $i < $cnt; $i++) {
        $sid .= pack('V', $v[$i + 3]);
    }
    return $sid;
}
