/**
 * Returns additional information for groupType.
 * @param int $type Value of the groupType attribute
 */
function groupType2str($type) {
    static $flags = array(
        'SECURITY_ENABLED' => 0x80000000,
        'ACCOUNT_GROUP' => 0x02,
        'RESOURCE_GROUP' => 0x04,
        'UNIVERSAL_GROUP' => 0x08,
    );
    $info = array();
    foreach ($flags as $name => $value) {
        if ($type & $value) {
            $info[] = $name;
        }
    }
    return dec2hex($type) . ' (' . join(',  ', $info) . ')';
}