<?php
namespace net\xmp\phpbook;
require './ExchangeSoapClient.php';
require './HTMLPage.php';

$options = array('trace' => true, 'CACert' => './my-ca.cer',
                 'login' => 'doris', 'password' => 'confidential');
$client = new ExchangeSoapClient("./Services.wsdl", $options);

$param = array('FolderShape' => array('BaseShape' => 'Default'),
               'FolderIds' => array(
                    'DistinguishedFolderId' => array(array('Id' => 'inbox'),
                                                     array('Id' => 'drafts'))));
try {
    $response = $client->GetFolder($param);
}
catch (\Exception $e) {
    echo '<h1>Exception</h1>', $e;
    var_dump($client->curl_info);
    exit;
}
$page = new HTMLPage('EWS-Test');
$page->addElement('h1', 'Request');
$page->addElement('h2', 'Data');
$page->addElement('p', $client->__getLastRequest());
$page->addElement('h2', 'Header');
$page->addElement('pre', $client->__getLastRequestHeaders(), true);
$page->addElement('h1', 'Response');
$page->addElement('h2', 'Data');
$page->addElement('p', $client->__getLastResponse());
$page->addElement('h2', 'Header');
$page->addElement('pre', $client->__getLastResponseHeaders(), true);
$page->addElement('h1', 'Generated response object');
$page->addElement('pre', print_r($response,  true), true);
$page->printPage();
?>
