<?php
namespace net\xmp\phpbook;
require './ExchangeSoapClient.php';
require './HTMLPage.php';

$page = new HTMLPage('Decline meeting request');
$options = array('login' => 'tony', 'password' => 'confidential',
                 'CACert' => './my-ca.cer');
$client = new ExchangeSoapClient('./Services.wsdl', $options);

// Search inbox
$param = array('Traversal' => 'Shallow',
    'ItemShape' => array('BaseShape' => 'IdOnly'),
    'ParentFolderIds' => array('DistinguishedFolderId' => array('Id' => 'inbox')));
$response = $client->FindItem($param);

// Select the first meeting invitation
$item = $response->ResponseMessages->FindItemResponseMessage->RootFolder->Items->MeetingRequest;
$item = $item[0];

// Retrieve selected meeting invitation
$param = array('ItemShape' => array('BaseShape' => 'Default'),
    'ItemIds' => array('ItemId' => array('Id' => $item->ItemId->Id,
                                         'ChangeKey' => $item->ItemId->ChangeKey)));
$response = $client->GetItem($param);
$item = $response->ResponseMessages->GetItemResponseMessage->Items->MeetingRequest;

// Display meeting invitation
$table = array(array('Field', 'value'));
$table[] = array('Subject', $item->Subject);
$table[] = array('Start time', $item->Start);
$table[] = array('End time', $item->End);
$table[] = array('Location', $item->Location);
$table[] = array('Organizer', $item->Organizer->Mailbox->Name);
$table[] = array('ItemID (before): ', splitString($item->ItemId->Id));
$table[] = array('CalendarItemID (before): ', splitString($item->AssociatedCalendarItemId->Id));
$page->addTable($table);

// Send decline message
$param = array('MessageDisposition' => 'SendOnly',
    'Items' => array('DeclineItem' => array(
            'ReferenceItemId' => array('Id' => $item->ItemId->Id,
                                       'ChangeKey' => $item->ItemId->ChangeKey),
            'Body' => array('BodyType' => 'Text',
                            '_' => 'I have to feed my hamsters.'))));
$response = $client->CreateItem($param);

// Display response
$page->addElement('h2', 'SOAP response message');
$items = $response->ResponseMessages->CreateItemResponseMessage->Items;
$table = array(array('Field', 'Value'));
$table[] = array('ItemID (after): ', splitString($items->MeetingRequest->ItemId->Id));
$table[] = array('CalendarItemID (after): ', splitString($items->CalendarItem->ItemId->Id));
$page->addTable($table);
$page->printPage();

// Auxiliary function: Insert space to allow line break
function splitString($str) {
   return preg_replace('/(.{33})/', '$1  ', $str);
}
?>
